#include <iostream>
#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#include <math.h>
#include <float.h>

using namespace std;

/////////////////////////////////////////////////////////////
// Variables Globales
/////////////////////////////////////////////////////////////
// Taille de la fenêtre
unsigned width  = 600;
unsigned height = 600;

// Couleurs
double RED  [3] = {1, 0, 0};
double GREEN[3] = {0, 1, 0};
double BLUE [3] = {0, 0, 1};
double CYAN [3] = {0, 1, 1};

// Mouse X, Y
double x_0, y_0;		// Start
double x_c, y_c;		// Current

// Other
int		pressed_button =-1;
double  angle          = 45.0;
double  matrix [16]    = {1.0, 0.0, 0.0, 0.0,
						  0.0, 1.0, 0.0, 0.0,
						  0.0, 0.0, 1.0, 0.0,
						  0.0, 0.0, 0.0, 1.0};

/////////////////////////////////////////////////////////////
// Other
/////////////////////////////////////////////////////////////
double* cross_product(double* v1, double* v2) {
	double* v3 = new double[3];

	// A vous d'implementer

	return v3;
}

double scalar_product(double* v1, double* v2) {
	return 0.0;
}

double dist(float x0, float y0, float x1, float y1) {
  return sqrt((x0-x1)*(x0-x1) + (y0-y1)*(y0-y1));
}

/////////////////////////////////////////////////////////////
// Commandes
/////////////////////////////////////////////////////////////
void motion(int x, int y) {
	x_c = 2.0f*(double(x)-double( width)/2.0)/double( width);
    y_c =-2.0f*(double(y)-double(height)/2.0)/double(height); 

	double d_x = x_c - x_0, d_y = y_c - y_0;
	switch (pressed_button) {
	case GLUT_LEFT_BUTTON:
		// Rotation
		break;

	case GLUT_MIDDLE_BUTTON:
		// Zoom
		break;

	case GLUT_RIGHT_BUTTON:
		// Translation
		break;

	default:
		break;
	}

	glutPostRedisplay();
}

void mouse(int button, int state, int x, int y) {
    x_0 = 2.0f*(double(x)-double( width)/2.0)/double( width);
    y_0 =-2.0f*(double(y)-double(height)/2.0)/double(height); 

    if (state == GLUT_DOWN) {
        pressed_button =  button;
	} else {
		pressed_button = -1;
	}

    glutPostRedisplay();
}

void keyboard(unsigned char key, int x, int y) {
    switch (key) {
    case 27:    // Echap
        exit(0);
	case ' ':
		break;
    default:
        return;
    }
    glutPostRedisplay();
}

/////////////////////////////////////////////////////////////
// Fonctions Ecran
/////////////////////////////////////////////////////////////
void window_reshape(int w, int h) {
    width  = w;
    height = h;
    glViewport(0, 0, w, h);
    glutPostRedisplay();
}

void draw_objects() {
	// Projection 3D
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(angle, (double)width/height, 0.001, 100);

	// Positionnement Caméra
	gluLookAt( 0, 0,-5,         // Camera Position
			   0, 0, 0,			// Camera Direction
			   0, 1, 0);		// Camera Up

	// Vue Caméra
	glMatrixMode(GL_MODELVIEW);  
	glPushMatrix();

	// Affichage theiere
	glColor3dv(CYAN); // Cyan
	glutWireTeapot(1);

	// Affichage Origine
	glLineWidth(5.0);
	glBegin(GL_LINES);
	glColor3dv(RED); // Rouge /Axe X
	glVertex3d(0, 0, 0);
	glVertex3d(2, 0, 0);

	glColor3dv(GREEN); // Vert /Axe Y
	glVertex3d(0, 0, 0);
	glVertex3d(0, 2, 0);

	glColor3dv(BLUE); // Bleue /Axe Z
	glVertex3d(0, 0, 0);
	glVertex3d(0, 0, 2);
	glEnd();
	glLineWidth(1.0);

	glPopMatrix();	
}

void draw_scene(void) {
    // Initialisation de la fenêtre
    glPushMatrix();
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

    // Création des objets
    draw_objects();

    // Swap pour afficher la prochaine fenêtre
    glutSwapBuffers();
    glPopMatrix();
}

/////////////////////////////////////////////////////////////
// Main
/////////////////////////////////////////////////////////////
int main(int argc, char *argv[]) {
    // Initialisation de Glut
    glutInit           (&argc, argv);
    glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE | GLUT_MULTISAMPLE | GLUT_STENCIL);
    glClearColor(0.3f, 0.3f, 0.3f, 1.0f);
    glEnable(GL_POINT_SMOOTH);
    glEnable(GL_POINT_SIZE);

    // Taille et position de la fenêtre
	glutInitWindowSize    (width, height);    // Window Size     600x600
    glutInitWindowPosition(  200,      0);

    // Création et Titre de la fenêtre
    glutCreateWindow("Synthese d'Image 1");

    // Fonction d'affichage (Renvoi à la fonction draw_scene)
    glutDisplayFunc(draw_scene);

    // Fonctions liers aux différentes commandes
    glutMouseFunc   (   mouse);
	glutMotionFunc  (  motion);
    glutKeyboardFunc(keyboard);

    // Fonction lier à la mise à l'échelle de la fenêtre
    glutReshapeFunc (window_reshape);

    glutSwapBuffers();
    glutMainLoop();
    return 0;
}
